# -*- coding: utf-8 -*-
import functools
import tensorflow as tf

import functools
import sys
sys.path.append('/home/ipiu/Documents/VOT2019/model/MBMD-master/lib')
sys.path.append('/home/ipiu/Documents/VOT2019/model/MBMD-master/lib/slim')

from object_detection.builders import optimizer_builder
from object_detection.builders import preprocessor_builder
from object_detection.core import batcher
from object_detection.core import preprocessor
from object_detection.core import standard_fields as fields
from object_detection.utils import ops as util_ops
from object_detection.utils import variables_helper
from deployment import model_deploy

from core import trainer_seq, input_reader
# from core import input_reader
from core.model_builder import build_man_model
from google.protobuf import text_format
from object_detection.builders import input_reader_builder
from object_detection.protos import input_reader_pb2
from object_detection.protos import model_pb2
from object_detection.protos import pipeline_pb2
from object_detection.protos import train_pb2
import os

os.environ["CUDA_VISIBLE_DEVICES"]="1"

tf.logging.set_verbosity(tf.logging.INFO)

flags = tf.app.flags

flags.DEFINE_string('train_dir', '/home/ipiu/Documents/VOT2019/model/MBMD-master/vot_train/model/dump',
                    'Directory to save the checkpoints and training summaries.')
flags.DEFINE_string('pipeline_config_path', '/home/ipiu/Documents/VOT2019/model/MBMD-master/pre_model/model/ssd_mobilenet_tracking.config',
                    'Path to a pipeline_pb2.TrainEvalPipelineConfig config '
                    'file. If provided, other configs are ignored')
flags.DEFINE_string('train_config_path', '',
                    'Path to a train_pb2.TrainConfig config file.')
flags.DEFINE_string('input_config_path', '',
                    'Path to an input_reader_pb2.InputReader config file.')
flags.DEFINE_string('model_config_path', '',
                    'Path to a model_pb2.DetectionModel config file.')
flags.DEFINE_string('image_root', '/home/ipiu/Documents/VOT2019/model/MBMD-master/vot_train/img/ILSVRC2014_train_0001',
                    'Root path to input images')

FLAGS = flags.FLAGS
slim = tf.contrib.slim


def get_configs_from_pipeline_file():
  """Reads training configuration from a pipeline_pb2.TrainEvalPipelineConfig.

  Reads training config from file specified by pipeline_config_path flag.

  Returns:
    model_config: model_pb2.DetectionModel
    train_config: train_pb2.TrainConfig
    input_config: input_reader_pb2.InputReader
  """
  pipeline_config = pipeline_pb2.TrainEvalPipelineConfig()
  with tf.gfile.GFile(FLAGS.pipeline_config_path, 'r') as f:
    text_format.Merge(f.read(), pipeline_config)

  model_config = pipeline_config.model.ssd
  train_config = pipeline_config.train_config
  input_config = pipeline_config.train_input_reader

  return model_config, train_config, input_config

def main(_):

    model_config, train_config, input_config = get_configs_from_pipeline_file()
    model_fn = functools.partial(build_man_model,model_config=model_config,is_training=True)
    create_input_dict_fn = functools.partial(input_reader.read, input_config)
    print("成功读入数据!")

    trainer_seq.train(model_fn, create_input_dict_fn, train_config, FLAGS.train_dir, FLAGS.image_root)






if __name__ == '__main__':

  # update moving average
  tf.app.run()
